var domElement = function (selector) {
  this.selector = selector || null;
  this.element = null;
};

var DOMel = domElement.prototype;

DOMel.init = function () {
  switch (this.selector[0]) {
    case "<":
      var matches = this.selector.match(/<([\w-]*)>/);
      if (matches === null || matches === undefined) {
        throw "Invalid Selector / Node";
        return false;
      }
      var nodeName = matches[0].replace("<", "").replace(">", "");
      this.element = document.createElement(nodeName);
      break;
    default:
      this.element = document.querySelector(this.selector);
  }
};

DOMel.on = function (event, callback) {
  var evt = this.eventHandler.bindEvent(event, callback, this.element);
};

DOMel.off = function (event) {
  var evt = this.eventHandler.unbindEvent(event, this.element);
};

DOMel.val = function (newVal) {
  return newVal !== undefined
    ? (this.element.value = newVal)
    : this.element.value;
};

DOMel.ready = function (func) {
  document.onload = func;
};

DOMel.aftrender = function (html) {
  this.element.innerHTML = this.element.innerHTML + html;
};

DOMel.prerender = function (html) {
  this.element.innerHTML = html + this.element.innerHTML;
};

DOMel.empty = function () {
  this.element.innerHTML = "";
};

DOMel.render = function (html) {
  if (html === undefined) {
    return this.element.innerHTML;
  }
  this.element.innerHTML = html;
};

DOMel.after = function (el) {
  target.insertAdjacentElement("afterend", el);
};

DOMel.before = function (el) {
  target.insertAdjacentElement("beforebegin", el);
};

DOMel.style = function (style) {
  if (style === undefined) {
    return this.element.style;
  }
  this.element.style = style;
};

DOMel.addclass = function (Class) {
  if (Class === undefined) {
    return this.element.classList;
  }
  this.element.classList.add(Class);
};

DOMel.delclass = function (className) {
  if (className === undefined) {
    return this.element.classList;
  }
  this.element.classList.remove(className);
};

DOMel.getJSON = function (url) {
  var request = new XMLHttpRequest();
  request.open("GET", url, true);

  request.onload = function () {
    if (this.status >= 200 && this.status < 400) {
      var data = JSON.parse(this.response);
      return data;
    } else {
      throw "server reached, but error returned";
    }
  };

  request.onerror = function () {
    // There was a connection error of some sort
    throw "server not reached, connection error";
  };

  request.send();
};

DOMel.ajax = function (type, url, data) {
  if ((type = "POST")) {
    var request = new XMLHttpRequest();
    request.open("POST", url, true);
    request.setRequestHeader(
      "Content-Type",
      "application/x-www-form-urlencoded; charset=UTF-8"
    );
    request.send(data);
  }

  if ((type = "GET")) {
    data = null;
    var request = new XMLHttpRequest();
    request.open("GET", "/my/url", true);

    request.onload = function () {
      if (this.status >= 200 && this.status < 400) {
        var resp = this.response;
        return resp;
      } else {
        throw "server reached, but error returned";
      }
    };

    request.onerror = function () {
      throw "server not reached, connection error";
    };

    request.send();
  }
};

DOMel.includeHTML = function (attribute) {
  var z, i, elmnt, file, xhttp;
  /*loop through a collection of all HTML elements:*/
  z = document.getElementsByTagName("*");
  for (i = 0; i < z.length; i++) {
    elmnt = z[i];
    /*search for elements with a certain atrribute:*/
    file = elmnt.getAttribute(attribute);
    if (file) {
      /*make an HTTP request using the attribute value as the file name:*/
      xhttp = new XMLHttpRequest();
      xhttp.onreadystatechange = function () {
        if (this.readyState == 4) {
          if (this.status == 200) {
            elmnt.innerHTML = this.responseText;
          }
          if (this.status == 404) {
            elmnt.innerHTML = "Page not found.";
          }
          /*remove the attribute, and call this function once more:*/
          elmnt.removeAttribute("include");
          includeHTML();
        }
      };
      xhttp.open("GET", file, true);
      xhttp.send();
      /*exit the function:*/
      return;
    }
  }
}

DOMel.eventHandler = {
  events: [],
  bindEvent: function (event, callback, targetElement) {
    this.unbindEvent(event, targetElement);
    targetElement.addEventListener(event, callback, false);
    this.events.push({
      type: event,
      event: callback,
      target: targetElement,
    });
  },
  findEvent: function (event) {
    return this.events.filter(function (evt) {
      return evt.type === event;
    }, event)[0];
  },
  unbindEvent: function (event, targetElement) {
    var foundEvent = this.findEvent(event);
    if (foundEvent !== undefined) {
      targetElement.removeEventListener(event, foundEvent.event, false);
    }
    this.events = this.events.filter(function (evt) {
      return evt.type !== event;
    }, event);
  },
};

verge = function (selector) {
  var el = new domElement(selector);
  el.init();
  return el;
};
